*** mboxcmd.c (std)	Fri Nov 20 03:11:30 1998
--- mboxcmd.c (new)	Sat Jun 09 04:22:52 2001
***************
*** 186,191 ****
--- 186,194 ----
  /* mbox subcommand table */
  static struct cmds DFAR Mbtab[] = {
      "alias",        doaliases,      0, 0, NULLCHAR,
+ #ifdef MBMENU
+     "menu",         domenus,        0, 0, NULLCHAR,
+ #endif
  #ifdef TTYLINKSERVER
      "attend",       doattend,       0, 0, NULLCHAR,
  #endif
***************
*** 355,360 ****
--- 358,472 ----
      return a;
  }
    
+ #ifdef MBMENU
+ struct menu *MenuList;
+ 
+ // add, delete or show menu items
+ int
+ domenus(int argc,char *argv[],void *p) {
+     struct menu *m;
+     int len;
+ 
+     if(argc == 1) {  // show all items of all menus
+         for(m=MenuList;m;m=m->next) {
+             tprintf("%s: %s \"%s\"",m->name,m->item,m->cmd);
+             if(strlen(m->prompt))
+                 tprintf(" \"%s\"",m->prompt);
+             if(strlen(m->gotomenu))
+                 tprintf(" %s",m->gotomenu);
+             tputs("\n");
+         }
+         return 0;
+     }
+ 
+     if(argc == 2) {  // show all items of a single menu
+         for(m=MenuList;m;m=m->next)
+             if(!stricmp(m->name,argv[1])) {
+                 tprintf("%s: \"%s\"",m->item,m->cmd);
+                 if(strlen(m->prompt))
+                     tprintf(" \"%s\"",m->prompt);
+                 if(strlen(m->gotomenu))
+                     tprintf(" %s",m->gotomenu);
+                 tputs("\n");
+             }
+         return 0;
+     }
+ 
+     if(argc == 3) {  // show a single item of a single menu
+         for(m=MenuList;m;m=m->next)
+             if(!stricmp(m->name,argv[1]) &&
+                 !stricmp(m->item,argv[2])) {
+                 tprintf("%s: \"%s\"",m->item,m->cmd);
+                 if(strlen(m->prompt))
+                     tprintf(" \"%s\"",m->prompt);
+                 if(strlen(m->gotomenu))
+                     tprintf(" %s",m->gotomenu);
+                 tputs("\n");
+                 break;
+             }
+         return 0;
+     }
+ 
+     // now either delete or add a menu !
+     if((len=strlen(argv[3])) == 0) {  // delete a menu
+         struct menu *p = NULL;
+ 
+         for(m=MenuList;m;p=m,m=m->next) {
+             if(!stricmp(m->name,argv[1]) &&
+                 !stricmp(m->item,argv[2]) ) {
+                 if(p)
+                     p->next = m->next;
+                 else
+                     MenuList = m->next;
+                 free(m->name);
+                 free(m->item);
+                 free(m->cmd);
+                 free(m->prompt);
+                 free(m->gotomenu);
+                 free(m);
+                 break;
+             }
+         }
+     } else {    // add a new menu item or change an existing one
+         if(len > MBXLINE) {
+             puts("Menu command too long!\n");
+             return 1;
+         }
+         for(m=MenuList;m;m=m->next)    // see if menu item exists
+             if(!stricmp(m->name,argv[1]) &&
+                 !stricmp(m->item,argv[2]))
+                 break;
+         if(!m) {    // if not, add a new one
+             m = mallocw(sizeof(struct menu));
+             m->next  = MenuList;
+             MenuList = m;
+             m->name  = strdup(argv[1]);
+             m->item  = strdup(argv[2]);
+         }
+         else {   // otherwise change it
+             free(m->cmd);
+             free(m->prompt);
+             free(m->gotomenu);
+         }
+         m->cmd      = strdup(argv[3]);
+         m->prompt   = strdup(argv[4]);
+         m->gotomenu = strdup(argv[5]);
+     }
+     return 0;
+ }
+ 
+ struct menu *findmenuitem(char *menu, char *item) {
+ 	 struct menu *m;
+ 
+ 	 // check with the menu list
+ 	 for(m=MenuList;m;m=m->next)
+ 		  if(!stricmp(m->name,menu) && !stricmp(m->item,item))
+ 				break;
+ 	 return m;
+ }
+ #endif
+ 
+ 
    
  char Mbnrid[20];
    
